/* **************************************************************************
*                                                                           *
*  Mutex.CPP                                                                *
*                                                                           *
*  08-03-97                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Classe per a la utilitzaci de 'mutex'                                   *
*                                                                           *
************************************************************************** */

// *********************************** INCLUDES
#include "fenix\mutex.h"
#include "fenix\mailbox.h"
#include "fenix\asm.h"
#include "fenix\fenix.h"

CfnxMutex::CfnxMutex( PCfnxObject pParent, PSTR sName ) : CfnxResource()
	{
	id = CID_Mutex;

	PCfnxMailBox box = new CfnxMailBox();

	TMSG msg;

	msg.dwMessage	= SYS_CREATE_MUTEX;

	if( pParent )
		msg.dwParam1	= (DWORD) pParent->GetInternalPointer();
	else
		msg.dwParam1	= 0;

	msg.dwParam2	= (DWORD) sName;
	msg.pReply		= box->GetInternalPointer();

	PostMessage( Fenix->MailBox(), &msg );

	box->WaitMessage( &msg );
	delete box;

	pobject = (PVOID) msg.dwParam1;
	}

CfnxMutex::~CfnxMutex()
	{
	PCfnxMailBox box = new CfnxMailBox();

	TMSG msg;

	msg.dwMessage	= SYS_DESTROY_MUTEX;
	msg.dwParam1	= (DWORD) pobject;
	msg.dwParam2	= 0;
	msg.pReply		= box->GetInternalPointer();

	PostMessage( Fenix->MailBox(), &msg );

	box->WaitMessage( &msg );
	delete box;
	}

BOOL CfnxMutex::ClassCheck( CUID Cuid )
	{
	if( Cuid == CID_Mutex )
		return TRUE;
	else
		return CfnxResource::ClassCheck( Cuid );
	}

