/* **************************************************************************
*                                                                           *
*  NFUHelp.CPP                                                              *
*                                                                           *
*  13-07-96                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Classe per a la implementaci de l'algorisme NFU per a la memria        *
*                                                                           *
************************************************************************** */

// *********************************** INCLUDES
#include "kernel\nfuhelp.h"
#include "kernel.h"
#include "errors.h"

// **************************************************************************
// Constructor de la classe
// Com a entrada ha de rebre:
// pEntry   	- Apuntador a l'entrada de pgina
// pNext    	- NFUHelper segent
CNFUHelper::CNFUHelper( PTPage pEntry, PCNFUHelper pNext ) : CkeListItem( pNext )
	{
	PageEntry( pEntry );
	}

// **************************************************************************
// Destructor de la classe
CNFUHelper::~CNFUHelper()
	{
	}

// **************************************************************************
// Indica si la classe de l'objecte s o no la que es passa com a parmetre
// Com a entrada ha de rebre:
// Cuid     	- Identificador de la classe
BOOL CNFUHelper::ClassCheck( CUID Cuid )
	{
	if( Cuid == CID_NFUHelper )
		return TRUE;
	else
		return CkeListItem::ClassCheck( Cuid );
	}

// **************************************************************************
// Retorna l'adrea de l'entrada de pgina (o NULL si no est en memria)
PTPage CNFUHelper::PageEntry()
	{
	return ppageentry;
	}

// **************************************************************************
// Selecciona una nova adrea de l'entrada de pgina (o NULL si es treu de mem.)
// Com a entrada ha de rebre:
// pEntry   	- Apuntador a l'entrada de pgina
VOID CNFUHelper::PageEntry( PTPage pEntry )
	{
	ppageentry = pEntry;
	}

