/* **************************************************************************
*                                                                           *
*  Common.H                                                                 *
*                                                                           *
*  26-02-97                                                    BUILD:0003   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Definicions comuns als mduls de 16 i 32 bits                            *
*                                                                           *
************************************************************************** */

#ifndef _COMMON1632_H
#define _COMMON1632_H

// Desplaament cap a la taula de mduls carregats
#define MODULE16_OFFSET			0x88000L
#define MODULE_16					0x88000000L

#define MAX_MODULE_NAME		13
#define MAX_IMAGES			15

// Tamany en 'bytes' de la PAT
#define PAT16_SIZE			16384
// Desplaament de 32bits cap a la PAT
#define PAT16_OFFSET			0x70000L
#define PAT_16					0x70000000L

// Adrea del directori de pgines de 16bits
#define PAGEDIR32_OFFSET	0x80000L
#define PAGEDIR_16			0x80000000L
// Nombre de pgines controlades des del mode real
#define PAGE_TABLES16		4
// Correspondncia de les pgines del mode real
#define PAGEDIR_ID			0L
#define SYSTABLE_ID			0x1000L
#define FIRSTMEG_ID			0x2000L
#define DRVTABLE_ID			0x3000L

// Adrea de la GDT i la IDT
#define GDT_OFFSET			0x4000L
#define IDT_OFFSET			0x1000L

// Preparem la GDT de 4KB amb  un descriptor reservat,
// un per a codi del SO i un altre per a dades del SO.
#define GDT_ENTRIES			512

// IDT_ENTRIES = Intel_Defined (32) + PIC (8 + 8) + SysCall (1)
#define IDT_ENTRIES			49

// *********************************** TIPUS
#ifdef __WIN32__
#pragma option -a1
#endif
typedef struct _TModule
	{
	CHAR	sName[ MAX_MODULE_NAME ];
	DWORD	dwEntryPoint;
	WORD	handle;
	} TModule, *PTModule;
#ifdef __WIN32__
#pragma option -a4
#endif

#endif

