/* **************************************************************************
*                                                                           *
*  Video.H                                                                  *
*                                                                           *
*  14-02-97                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Controlador de video de l'Eros                                           *
*                                                                           *
************************************************************************** */

#ifndef _vidVIDEO_H
#define _vidVIDEO_H

#include "consts.h"
#include "drivers\char\chardev.h"

#define VIDEO_MAILBOX		TEXT( "\\Driver\\Video" )
#define nVIDEO_MAILBOX		TEXT( "Video" )

#define BLINK_ATTR		0x80
#define BLACK				0x00
#define BLUE				0x01
#define GREEN				0x02
#define CYAN				0x03
#define RED					0x04
#define MAGENTA			0x05
#define BROWN				0x06
#define LIGHTGRAY			0x07
#define DARKGRAY			0x08
#define LIGHTBLUE			0x09
#define LIGHTGREEN		0x0A
#define LIGHTCYAN			0x0B
#define LIGHTRED			0x0C
#define LIGHTMAGENTA		0x0D
#define YELLOW				0x0E
#define WHITE				0x0F

_CLASSDEF( CdrvVideo )

class CdrvVideo : public CdrvCharDevice
	{
	protected:
		PVOID pvideoinstance;

	public:
		CdrvVideo();
		virtual ~CdrvVideo();

		VOID GotoXY( BYTE, BYTE );
		VOID Clear();
		VOID OutText( PSTR );
		CHAR GetChar( BYTE, BYTE );
		VOID SetChar( BYTE, BYTE, CHAR );

		BYTE GetAttribute( BYTE, BYTE );
		VOID SetAttribute( BYTE, BYTE, BYTE );

		BYTE GetColor();
		BYTE GetBkColor();
		VOID SetColor( BYTE );
		VOID SetBkColor( BYTE );

		BYTE GetX();
		BYTE GetY();

		PVOID GetInternalPointer();

		VOID Activate();

		VOID SetCaret( BOOL );
	};

#endif

