/* **************************************************************************
*                                                                           *
*  FUB.H                                                                    *
*                                                                           *
*  03-03-97                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Control genric dels fitxers d'usuari                                    *
*                                                                           *
************************************************************************** */

#ifndef _FUB_H
#define _FUB_H

#include "consts.h"
#include "kernel\list.h"
#include "kernel\pcb.h"

_CLASSDEF( CUserFile )

#include "sys\grantedr.h"
#include "drivers\fs\private\fcb.h"

#define READONLY		1
#define WRITEONLY		2
#define READWRITE		3

#define SEEK_SET		0
#define SEEK_CUR		1
#define SEEK_END		2

class CUserFile : public CkeDblListItem
	{
		CUserFile();

	protected:
		PCkeProcess pproc;
		DWORD dwposition;
		PCGlobalFile pfcb;
		PCsysGrantedRights prights;

	public:
		CUserFile( PCkeProcess, PCGlobalFile, BYTE );
		virtual ~CUserFile();

		virtual DWORD Read( PVOID, DWORD );
		virtual DWORD Write( PVOID, DWORD );
		virtual DWORD Seek( LONG, BYTE );
		virtual VOID Flush();

		VOID Lock( DWORD, DWORD, DWORD );
		VOID Unlock( DWORD, DWORD );

		VOID GetCreationTime( PTFILETIME );
		VOID GetLastAccessTime( PTFILETIME );
		VOID GetLastWriteTime( PTFILETIME );
		VOID GetCreationDate( PTFILEDATE );
		VOID GetLastAccessDate( PTFILEDATE );
		VOID GetLastWriteDate( PTFILEDATE );

		VOID SetCreationTime( PTFILETIME );
		VOID SetLastAccessTime( PTFILETIME );
		VOID SetLastWriteTime( PTFILETIME );
		VOID SetCreationDate( PTFILEDATE );
		VOID SetLastAccessDate( PTFILEDATE );
		VOID SetLastWriteDate( PTFILEDATE );

		DWORD GetAttributes();
		VOID SetAttributes( DWORD );
	};

#endif

