/* **************************************************************************
*                                                                           *
*  Messages.H                                                               *
*                                                                           *
*  13-02-97                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  'Defines' per als noms dels missatges pels dispositius de blocs          *
*                                                                           *
************************************************************************** */

#ifndef _drvMESSAGES_H
#define _drvMESSAGES_H

// Missatges que s'envien cap als controladors de disp.
#define DRV_GETNAME_DRIVER								0x00001100
#define DRV_GETDEVICENAME_DRIVER						0x00001101
#define DRV_GETVERSION_DRIVER							0x00001102
#define DRV_GETLEVEL_DRIVER							0x00001103
#define DRV_IOCTL_DRIVER								0x00001104
#define DRV_READ_DRIVER                         0x00001105
#define DRV_WRITE_DRIVER								0x00001106
#define DRV_GETSTATUS_DRIVER							0x00001107
#define DRV_ISLOCAL_DEVICE								0x00001110
#define DRV_ISREMOVABLE_DEVICE  						0x00001111
#define DRV_LOCK_DEVICE									0x00001112
#define DRV_CHECKMEDIA_DEVICE							0x00001113
#define DRV_HASMEDIA_DEVICE  							0x00001114
#define DRV_CANHASPAGEFILE_DEVICE					0x00001115
#define DRV_ISEXCLUSIVE_DEVICE						0x00001116

// dispositius de carcters
#define DRV_READBYTE_CHARDEV							0x00001120
#define DRV_WRITEBYTE_CHARDEV							0x00001121

// dispositius de blocs
#define DRV_READBLOCK_BLOCKDEV						0x00001130
#define DRV_WRITEBLOCK_BLOCKDEV						0x00001131
#define DRV_VERIFY_BLOCKDEV							0x00001122
#define DRV_FORMAT_BLOCKDEV							0x00001123

// Controladors de Video
#define DRV_CREATEINSTANCE_VID						0x00001200
#define DRV_DESTROYINSTANCE_VID						0x00001201
#define DRV_GOTOXY_VID									0x00001202
#define DRV_CLEAR_VID									0x00001203
#define DRV_OUTTEXT_VID									0x00001204
#define DRV_GETCHAR_VID									0x00001205
#define DRV_SETCHAR_VID									0x00001206
#define DRV_GETATTRIBUTE_VID							0x00001207
#define DRV_SETATTRIBUTE_VID							0x00001208
#define DRV_GETCOLOR_VID								0x00001209
#define DRV_SETCOLOR_VID								0x0000120A
#define DRV_GETBKCOLOR_VID								0x0000120B
#define DRV_SETBKCOLOR_VID								0x0000120C
#define DRV_ACTIVATE_VID								0x0000120D
#define DRV_GETX_VID										0x0000120E
#define DRV_GETY_VID										0x0000120F
#define DRV_SETCARET_VID								0x00001210

// Controladors de Teclat
#define DRV_CREATEINSTANCE_KEY						0x00001300
#define DRV_DESTROYINSTANCE_KEY						0x00001301
#define DRV_PUTCHAR_KEY									0x00001302
#define DRV_GETCHAR_KEY									0x00001303
#define DRV_CHECKCHAR_KEY								0x00001304
#define DRV_ACTIVATE_KEY								0x00001305

// Gestor de memria 'Cache' (Cache)
#define DRV_CREATE_CACHE								0x00001400
#define DRV_DESTROY_CACHE								0x00001401
#define DRV_FLUSHBLOCK_CACHE 							0x00001402

// Sistemes de fitxers
#define DRV_OPENFILE_FS	 								0x00001500
#define DRV_CLOSEFILE_FS  								0x00001501
#define DRV_READFILE_FS	 								0x00001502
#define DRV_WRITEFILE_FS  								0x00001503
#define DRV_SEEKFILE_FS	 								0x00001504
#define DRV_FLUSHFILE_FS	 							0x00001505
#define DRV_TELLFILE_FS	 								0x00001506
#define DRV_LOCKFILE_FS	 								0x00001507
#define DRV_UNLOCKFILE_FS 								0x00001508
#define DRV_DELETE_FS	 								0x00001509
#define DRV_RENAME_FS	 								0x0000150A
#define DRV_DUPHANDLE_FS	  							0x0000150B
#define DRV_SETFILESIZE_FS	  							0x0000150C
#define DRV_CREATE_FS	 								0x0000150D
#define DRV_SETATTRIBUTES_FS 							0x0000150E
#define DRV_GETATTRIBUTES_FS 							0x0000150F
#define DRV_GROWPAGEFILE_FS  							0x00001510
#define DRV_SHRINKPAGEFILE_FS							0x00001511
#define DRV_READPAGEFILE_FS 							0x00001512
#define DRV_WRITEPAGEFILE_FS 							0x00001513
#define DRV_PAGEFILESIZE_FS	 						0x00001514
#define DRV_GETNAME_FS									0x00001515

// Sistemes de fitxers (GlobalFile)
#define DRV_CREATEUSERFILE_FCB						0x00001600
/*
#define DRV_DESTROYUSERFILE_FCB						0x00001601
#define DRV_READFILE_FCB 								0x00001602
#define DRV_WRITEFILE_FCB 								0x00001603
#define DRV_SEEKFILE_FCB 								0x00001604
#define DRV_FLUSHFILE_FCB 								0x00001605
#define DRV_TELLFILE_FCB 								0x00001606
#define DRV_LOCKFILE_FCB 								0x00001607
#define DRV_UNLOCKFILE_FCB								0x00001608
#define DRV_SETATTRIBUTES_FCB							0x00001609
#define DRV_GETATTRIBUTES_FCB							0x0000160A
#define DRV_DUPHANDLE_FCB  							0x0000160B
#define DRV_SETFILESIZE_FCB  							0x0000160C
#define DRV_GETCREATIONTIME_FCB						0x0000160D
#define DRV_GETACCESSTIME_FCB							0x0000160E
#define DRV_GETWRITETIME_FCB							0x0000160F
#define DRV_GETCREATIONDATE_FCB						0x00001610
#define DRV_GETACCESSDATE_FCB							0x00001611
#define DRV_GETWRITEDATE_FCB							0x00001612
#define DRV_SETCREATIONTIME_FCB						0x00001613
#define DRV_SETACCESSTIME_FCB							0x00001614
#define DRV_SETWRITETIME_FCB							0x00001615
#define DRV_SETCREATIONDATE_FCB						0x00001616
#define DRV_SETACCESSDATE_FCB							0x00001617
#define DRV_SETWRITEDATE_FCB							0x00001618
*/

// Sistemes de fitxers (UserFile)
#define DRV_OPENFILE_FUB 								0x00001700
#define DRV_CLOSEFILE_FUB 								0x00001701
#define DRV_READFILE_FUB 								0x00001702
#define DRV_WRITEFILE_FUB 								0x00001703
#define DRV_SEEKFILE_FUB 								0x00001704
#define DRV_FLUSHFILE_FUB 								0x00001705
#define DRV_TELLFILE_FUB 								0x00001706
#define DRV_LOCKFILE_FUB 								0x00001707
#define DRV_UNLOCKFILE_FUB								0x00001708
#define DRV_SETATTRIBUTES_FUB							0x00001709
#define DRV_GETATTRIBUTES_FUB							0x0000170A
//#define DRV_DUPHANDLE_FUB  							0x0000170B
#define DRV_SETFILESIZE_FUB  							0x0000170C
#define DRV_GETCREATIONTIME_FUB						0x0000170D
#define DRV_GETACCESSTIME_FUB							0x0000170E
#define DRV_GETWRITETIME_FUB							0x0000170F
#define DRV_GETCREATIONDATE_FUB						0x00001710
#define DRV_GETACCESSDATE_FUB							0x00001711
#define DRV_GETWRITEDATE_FUB							0x00001712
#define DRV_SETCREATIONTIME_FUB						0x00001713
#define DRV_SETACCESSTIME_FUB							0x00001714
#define DRV_SETWRITETIME_FUB							0x00001715
#define DRV_SETCREATIONDATE_FUB						0x00001716
#define DRV_SETACCESSDATE_FUB							0x00001717
#define DRV_SETWRITEDATE_FUB							0x00001718

#endif

