/* **************************************************************************
*                                                                           *
*  Errors.H                                                                 *
*                                                                           *
*  16-02-97                                                    BUILD:0002   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Constants dels codis d'error                                             *
*                                                                           *
************************************************************************** */

#ifndef _ERRORS_H
#define _ERRORS_H

#include "consts.h"

const DWORD
	OK							= 				0L,	// No hi ha error
	LDR_BAD					=				1L,	// Loader ha trobat un error sense especificar
	LDR_BAD_MZ_HDR			= 				2L,	// Capcelera MZ (MS-DOS) errnia
	LDR_BAD_PE_HDR			= 				3L,	// Capcelera PE (NT/Eros) errnia
	LDR_NOT_CERTIFIED		=				4L,	// Loader no ha certificat el fitxer
	LDR_BAD_MACHINE		=				5L,	// Mquina no soportada
	LDR_BAD_VERSION		=				6L,	// Versi del sistema incompatible
	LDR_BAD_SUBSYSTEM		=				7L,	// Versi del subsistema incompatible
	LDR_BAD_SECTION		=				8L,	// Secci cercada no trobada
	FIL_BAD					=			 100L,	// Algun error en el fitxer
	FIL_EOF					=			 101L,	// Trobat el final del fitxer
	FIL_BAD_FILESPEC		=			 102L,	// Filespec invalid
	FIL_BAD_FILE			=			 103L,	// Intent d'obrir alguna cosa que no s un fitxer
	FIL_NOFILE				=			 104L,	// No existeix el fitxer
	FIL_READONLY			=			 105L,	// No es pot modificar el fitxer
	FIL_BAD_MODE			=			 106L,	// Error en el mode especificat
	FIL_INUSE				=			 107L,	// El fitxer ja est obert i no s compartible
	FIL_BAD_HANDLE			=			 108L,	// Handle de fitxer incorrecte
	FIL_BROKEN				=			 109L,	// Cadena de clusters del fitxer trencada
	FIL_STREAM				=			 110L,	// Operaci no permesa en streams
	FIL_BLOCK				=			 111L,	// Operaci no permesa en fitxers per blocs
	FIL_BEYOND_EOF			=			 112L,	// Estem ms enll del final del fitxer
	FIL_WRITEONLY			=			 113L,	// Intent de llegir un dispositiu de noms escriptura
	FIL_NOT_SUPPORTED		=			 114L,	// Operaci no suportada pel fitxer
	FS_BAD					=         150L,	// FileSystem ha trobat un error sense especificar
	FS_BAD_DRIVE			=			 151L,	// Especificat un disc inexistent
	FS_BAD_NODIR			=			 152L,	// No existeix el subdirectori
	FS_NOFCB					=			 153L,	// No queden FCBs lliures
	FS_NOFUB					=			 154L,	// No queden FUBs lliures
	FS_BAD_FCB				=			 155L,	// FCB especificat erroni
	FS_BAD_PARTITION		=			 156L,	// Taula de particions incorrecta
	FS_BAD_FAT				=			 157L,	// Clusters de la FAT erronis
	FS_RENAME_DRV			=			 158L,	// No es pot renombrar canviant de disc
	FS_RENAME_DIR			=			 159L,	// No es pot renombrar canviant de directori
	FS_NO_MATCH				=			 160L,	// Entrada de directori no trobada
	FS_DUP_NAME				=			 161L,	// El nom esta duplicat
	FS_ROOT_FULL			=			 162L,	// L'arrel est plena
	FS_DISK_FULL			=			 163L,	// El disc esta pl
	FS_NEW_MEDIA			=			 164L,	// Nou disc introdut
	SECTN_UNINITIALIZED	=			 200L,	// Secci no inicialitzada
	SECTN_NOTFOUND			=			 201L,	// Secci no trobada
	DESC_UNINITIALIZED	=			 222L,	// Descriptor no inicialitzat
	DESC_BAD_TYPE			=			 223L,	// Tipus incorrecte per a l'operaci
	DESC_ALREADYFREE		=			 224L,	// Intent d'alliberar un descriptor lliure
	DESC_NOFREESPACE		=			 225L,	// No es poden crear ms descriptors
	DESC_ALREADYMADE		=			 226L,	// Intent de crear un nou descriptor en un d'existent
	TSS_UNINITIALIZED		=			 240L,	// TSS no inicialitzat
	TSS_STACKLEVEL			=			 241L,	// Intent d'accedir a una pila incorrecta del TSS
	GDT_UNINITIALIZED		=			 260L,	// GDT no inicialitzada
	GDT_LIMITPASSED		=			 261L,	// S'intenta sobrepassar el limit de la GDT
	GATE_UNINITIALIZED	=			 270L,	// Gate no inicialitzada
	GATE_NOTPERMITTED		=			 271L,	// Operaci no permesa per a aquest tipus de porta
	IDT_UNINITIALIZED		=			 280L,	// IDT no inicialitzada
	IDT_LIMITPASSED		=			 281L,	// S'intenta sobrepassar el lmit de la IDT
	LDT_UNINITIALIZED		=			 290L,	// LDT no inicialitzada
	LDT_LIMITPASSED		= 			 291L,	// S'intenta sobrepassar el lmit de la LDT
	LST_NULLNEXT			=			 300L,	// S'intenta eliminar un objecte inexistent d'una llista
	PG_UNINITIALIZED		=			 310L,	// Objecte CPage no inicialitzat
	TPAG_UNINITIALIZED	=			 320L,	// Taula de pgines no inicialitzada
	TPAG_BAD_INDEX    	=			 321L,	// Referncia a un index de pgina incorrecte
	SYS_ALREADYMADE		=			 330L,	// Ja existeix una instncia de CSystem
	VIT_BADINT				=			 340L,	// La interrupci seleccionada no s vlida
	MEM_REGIONNOTFREE		=			 350L,	// La zona de memria ja est ocupada
	MEM_REGIONNOTRESERVED=			 351L,	// La zona de memria no est reservada
	CON_DIMENSION			=			 360L,	// La coordenada de pantalla s incorrecta
	RES_BADRELEASE			=			 370L,	// Intentem alliberar un recurs que no possem
	PCB_BADADDR				=			 380L,	// Parmetre 'pAddress' no vlid per al procs
	PD_BADREGION			=			 390L,	// La regi passada com a parmetre no s correcta
	UNSUPPORTED_FUNC		=			 400L,	// Funci no suportada
	KER_OUTOFTIMERS		=			 410L,	// Totes les alarmes ocupades
	KER_BADTIMER			=			 411L,	// L'objecte CTimer referenciat no s vlid
	MB_FULL					=			 420L,	// El MailBox est ple i s'intenta fer un PostMessage
	PAT_BADPAGE				=			 430L,	// La pgina passada com a parmetre no s vlida
	PAT_TOOMUCHUSED		=			 431L,	// La pgina que volem utilitzar ja s utilitzada per massa fluxos
	PAT_BADLET				=			 432L,	// Intentem fer un LetPage d'una pgina no utilitzada
	PT_BADPAGETABLE		=			 440L,	// L'adrea lgica passada com a parmetre no s vlida
	PT_FULLZONE				=			 441L,	// La zona de memria reservada a les taules de pgina s'ha exhaurit
	FDC_TIMEOUT				=			 450L,	// El controlador no ha reaccionat prou rpid
	FDC_BADRECAL			=			 451L,	// No s'ha realitzat correctament el recalibratge del dispositiu
	FDC_BADSEEK				=			 452L,	// S'ha intentat fer una cerca amb algun dels seus parmetres incorrecte
	FDC_BADCMD				=			 453L,	// La comanda o algun dels seus parmetres eren incorrectes
	FDC_READYLINE			=			 454L,	// Disquetera no preparada
	FDC_SECTNOTFOUND		=			 455L,	// Sector no trobat
	FDC_CRC					=			 456L,	// CRC erroni
	FDC_OVERRUN				=			 457L,	// El controlador no pot gestionar tanta informaci
	FDC_READONLY			=			 458L,	// Intentem escriure en un disc protegit
	FDC_ADDRMARK			=			 459L,	// La marca d'adrea del disquet s errnia
	FDC_BADFDC				=			 460L,	// La controladora ha fallat
	FDC_BADLBA				=			 461L,	// El bloc demanat s incorrecte
	IDE_NOTREADY			=			 470L,	// Controladora no preparada
	IDE_MISSINT				=			 471L,	// Interrupci perduda
	IDE_TIMEOUT				=			 472L,	// El controlador no ha reaccionat prou rpid
	IDE_TOOMANYBLOCKS		=			 473L,	// Massa blocs demanats en una sola operaci
	IDE_ZEROBLOCKS			=			 474L,	// No s'ha demanat cap bloc
	IDE_WRITEFAULT			=			 475L,	// Error durant l'escriptura
	IDE_BADSEEK				=			 476L,	// Cerca errnia
	IDE_ADDRESSMARK		=			 477L,	// Marca de l'adrea errnia
	IDE_BADHDC				=			 478L,	// El controlador ha fallat
	IDE_BADCMD				=			 479L,	// Comanda incorrecta
	IDE_SECTORNOTFOUND	=			 450L,	// El sector no s'ha trobat
	IDE_BADECC				=			 451L,	//	ECC erroni
	IDE_BADBLOCK			=			 452L,	// Bloc erroni
	UNKNOWN					=  0xffffffffL;	// Hi ha un error i es desconegut

#endif

