/* **************************************************************************
*                                                                           *
*  AcToken.H                                                                *
*                                                                           *
*  08-03-97                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Classe genrica de seguretat per a usuaris i grups                       *
*                                                                           *
************************************************************************** */

#ifndef _fnxACTOKEN_H
#define _fnxACTOKEN_H

#include "consts.h"
#include "fenix\type.h"

_CLASSDEF( CfnxAccessToken )

#define MAX_LONG_NAME			128
#define MAX_CALL_NAME			20

class CfnxAccessToken : public CfnxType
	{
		CfnxAccessToken();

	protected:
		PVOID paccesstoken;

	public:
		CfnxAccessToken( PVOID );
		virtual ~CfnxAccessToken();

		virtual BOOL ClassCheck( CUID );

		PVOID GetInternalPointer();

		VOID LongName( PSTR, DWORD );
		VOID Name( PSTR, DWORD );

		BOOL None();
		BOOL LockMemory();
		BOOL IncreaseQuota();
		BOOL LoadDriver();
		BOOL Systemtime();
		BOOL IncreaseBasePriority();
		BOOL CreatePageFile();
		BOOL Backup();
		BOOL Restore();
		BOOL Shutdown();
		BOOL Debug();
		BOOL Audit();

		VOID LongName( PSTR );
		VOID Name( PSTR );

		VOID None( BOOL );
		VOID LockMemory( BOOL );
		VOID IncreaseQuota( BOOL );
		VOID LoadDriver( BOOL );
		VOID Systemtime( BOOL );
		VOID IncreaseBasePriority( BOOL );
		VOID CreatePageFile( BOOL );
		VOID Backup( BOOL );
		VOID Restore( BOOL );
		VOID Shutdown( BOOL );
		VOID Debug( BOOL );
		VOID Audit( BOOL );
	};

#endif

