/* **************************************************************************
*                                                                           *
*  Gate.H                                                                   *
*                                                                           *
*  13-07-96                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Classe per al control de les portes en general                           *
*                                                                           *
************************************************************************** */

#ifndef _GATE_H
#define _GATE_H

#include "types.h"
#include "kernel\descr.h"

typedef struct _TGate
	{
	WORD OffsetLo;
	WORD Selector;
	union
		{
		struct
			{
			BYTE Params;
			BYTE Type;
			} Bytes;
		struct
			{
			BYTE Params : 5;
			BYTE Reserved_0 : 3;
			BYTE Type : 5;
			BYTE DPL : 2;
			BYTE Pres : 1;
			} Bits;
		} Flags;
	WORD OffsetHi;
	} TGate, *PTGate;

_CLASSDEF( CGate )

class CGate : public CDescriptor
	{
	protected:
	public:
		CGate( PTDescriptor = NULL );
		virtual ~CGate();

		virtual BOOL ClassCheck( CUID Cuid );

		virtual BYTE Params();
		virtual WORD Selector();
		virtual DWORD Offset();

		virtual VOID Params( BYTE );
		virtual VOID Selector( WORD );
		virtual VOID Offset( DWORD );

		virtual VOID Descriptor( PTDescriptor );
	};

#endif
