/* **************************************************************************
*                                                                           *
*  EXE.H                                                                    *
*                                                                           *
*  13-07-96                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Gesti dels fitxers executables                                          *
*                                                                           *
************************************************************************** */

#ifndef _EXE_H
#define _EXE_H

#include "consts.h"
#include "fs\headers.h"

_CLASSDEF( CExecutableFile )

#include "sys\section.h"
#include "kernel\tpags.h"
#include "kernel\pcb.h"
#include "fs\fub.h"

class CExecutableFile : public CkeType
	{
		CExecutableFile();

	protected:
		BOOL bcertified;
		PCUserFile pfile;
		IMAGE_DOS_HEADER dos_hdr;
		IMAGE_NT_HEADERS akula_hdr;

		void virtual Check_MZ_HDR();
		void virtual Check_PE_HDR();
		void virtual CertifyExecutable();

	public:
		CExecutableFile( PCUserFile );
		virtual ~CExecutableFile();

// File Header
		WORD		Machine();
		WORD		NumberOfSections();
		WORD		FileFlags();

// Optional Header
		DWORD		SizeOfCode();
		DWORD		SizeOfInitializedData();
		DWORD		SizeOfUninitializedData();
		DWORD		AddressOfEntryPoint();
		DWORD		ImageBase();
		DWORD		SectionAlignment();
		DWORD		FileAlignment();
		DWORD		OperatingSystemVersion();
		DWORD		SubsystemVersion();
		DWORD		SizeOfImage();
		DWORD		SizeOfHeaders();
		DWORD		CheckSum();
		WORD		Subsystem();
		WORD		DLLCharacteristics();
		DWORD		SizeOfStackReserve();
		DWORD		SizeOfStackCommit();
		DWORD		SizeOfHeapReserve();
		DWORD		SizeOfHeapCommit();
		DWORD		NumberOfRVAAndSizes();
		DWORD 		FirstSection();

		PCUserFile UserFile();
		virtual DWORD Run();
	};

#endif

