/* **************************************************************************
*                                                                           *
*  Section.H                                                                *
*                                                                           *
*  04-03-97                                                    BUILD:0001   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Classe per a la utilitzaci de les seccions                              *
*                                                                           *
************************************************************************** */

#ifndef _SECTION_H
#define _SECTION_H

#include "consts.h"
#include "kernel\list.h"
#include "drivers\fs\fub.h"
#include "sys\private\exe.h"
#include "kernel\pcb.h"

_CLASSDEF( CSection )

class CSection : public CkeDblListItem
	{
		CSection();

	protected:
		BOOL binitialized;
		PCExecutableFile pexe;
#pragma option -a1
		IMAGE_SECTION_HEADER section;
#pragma option -a4

	public:
		CSection( PCExecutableFile );
		virtual ~CSection();

		virtual BOOL ClassCheck( CUID );

		ASTR Name();
		DWORD VirtualSize();
		DWORD VirtualAddress();
		DWORD SizeOfRawData();
		DWORD PointerToRawData();
		DWORD Characteristics();

		VOID Initialize( ASTR );
		VOID Read( PCkeProcess );
	};

#endif

