/* **************************************************************************
*                                                                           *
*  Sys.H                                                                    *
*                                                                           *
*  08-03-97                                                    BUILD:0002   *
*                                                                           *
*  (c) Copyright, 1996-1997 de Daniel Vil i Amill                          *
*                                                                           *
*  Aquest fitxer pot ser utilitzat per a l's personal. No es pot vendre el *
*  seu contingut sense el previ consentiment per escrit de l'autor.         *
*  El material en aquest fitxer es distribueix "as is" i l'autor no es      *
*  responsabilitza dels danys que pugui causar-ne el seu s.                *
*                                                                           *
*                                                                           *
*  Nivell System de l'Eros ver 0.0.1                                        *
*                                                                           *
************************************************************************** */

#ifndef _sysSYSTEM_H
#define _sysSYSTEM_H

#include "sys\type.h"
#include "sys\driver.h"
#include "sys\thread.h"
#include "sys\pcb.h"
#include "time.h"

#define SYS_MAILBOX			TEXT( "\\Mailbox\\System" )
#define nSYS_MAILBOX			TEXT( "System" )

#define MAX_COMPUTERNAME	15

_CLASSDEF( CsysModule )

class CsysModule : public CsysType
	{
	protected:
		PVOID pbox;
		PVOID pnullbox;

	public:
		CsysModule();
		virtual ~CsysModule();

		PVOID MailBox();
		PVOID NULLMailBox();

		VOID GetComputerName( PSTR, DWORD );
		VOID RegisterDriver( PTDriver );
		VOID UnregisterDriver( PTDriver );

		TTIME GetTime();
		TDATE GetDate();
		VOID SetTime( TTIME );
		VOID SetDate( TDATE );

		VOID RegisterShutdown( PVOID );
		VOID UnregisterShutdown( PVOID );
		VOID Shutdown( DWORD = 0 );
		VOID MemCopy( PBYTE, PBYTE, DWORD );
		VOID MemMove( PBYTE, PBYTE, DWORD );
		VOID MemSet( PBYTE, DWORD, BYTE );
		LONG MemCompare( PBYTE, PBYTE, DWORD );

		VOID ErrorCode( DWORD );
		DWORD ErrorCode();

		VOID Sleep( DWORD );

		VOID DriverReady();

		PCsysThread CreateThread( DWORD, DWORD, DWORD );
		BOOL Exec( PSTR );

		PCsysThread GetMe();
		PCsysProcess GetMyProcess();
	};

#endif

